%global Miniver 1.1.0.11
%global Minirev fb1929d
%global TAZ45ver 1.0.0.1
%global oliveoilver 1.0.2.22

%global buildfromsource 0

Name:		lulzbot-marlin-firmware
# Version comes from matching release of cura-lulzbot
Version:	21.08
Release:	2%{?dist}
Summary:	Marlin firmware files for the Lulzbot family of 3D printers
# this uses the arduino cross-compiler, so the output is arch-independent
BuildArch:	noarch
# Firmware source includes BSD, MIT, ISC, GPLv2+, GPLv3+, LGPLv2+, and LGPLv3+ licensed files
# Resulting combination is GPLv3+.
License:	GPLv3+
URL:		https://code.alephobjects.com/diffusion/MARLIN/
# https://code.alephobjects.com/w/marlin/current-stable-version/
#
# If we pull from git:
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout f5e8154d71470791112b70bca8c390a506a23640
# cd ..
# mv marlin Marlin_Gladiola/
# tar --exclude-vcs -czvf Marlin_Gladiola_v1.1.0.5_f5e8154.tar.gz Gladiola/
# Source0:	Marlin_Gladiola_v%%{Miniver}_%%{Minirev}.tar.gz
Source0:	https://devel.lulzbot.com/mini/Gladiola/software/firmware/Mini_Gladiola_Albatross_or_Brambling_v%{Miniver}_%{Minirev}.tar.gz
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout 1df0e3c64ea04ee57f0d2f8900411a9539f76436
# cd ..
# mv marlin TAZ45_standard_v2
# tar --exclude-vcs -cjvf TAZ45_standard_v2-1.0.0.1.tar.bz2 TAZ45_standard_v2/
Source1:	TAZ45_standard_v2-%{TAZ45ver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout 06306b157133cbf8d4eb3bf7c03bd487e7d71c62
# cd ..
# mv marlin TAZ45_flexy_v2
# tar --exclude-vcs -cjvf TAZ45_flexy_v2-1.0.0.1.tar.bz2 TAZ45_flexy_v2/
Source2:	TAZ45_flexy_v2-%{TAZ45ver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout c5aafd1ec4eb8d515fcc52b555af225b0fd0ea1d
# cd ..
# mv marlin TAZ45_flexydually_v2
# tar --exclude-vcs -cjvf TAZ45_flexydually_v2-1.0.0.1.tar.bz2 TAZ45_flexydually_v2/
Source3:	TAZ45_flexydually_v2-%{TAZ45ver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout 596a273f57e11509439500749e301be799e09cff
# cd ..
# mv marlin TAZ45_dual_v2
# tar --exclude-vcs -cjvf TAZ45_dual_v2-1.0.0.1.tar.bz2 TAZ45_dual_v2/
Source4:	TAZ45_dual_v2-%{TAZ45ver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout TAZ_6.02_Single_Extruder_v2.1_PID
# cd ..
# mv marlin oliveoil
# tar --exclude-vcs -cjvf oliveoil-1.0.2.22.tar.bz2 oliveoil/
Source5:	oliveoil-%{oliveoilver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout TAZ_6.02_Flexystruder_v2_PID
# cd ..
# mv marlin oliveoil_flexy
# tar --exclude-vcs -cjvf oliveoil_flexy-1.0.2.22.tar.bz2 oliveoil_flexy/
Source6:	oliveoil_flexy-%{oliveoilver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout TAZ_6.02_Dual_Extruder_v2_PID
# cd ..
# mv marlin oliveoil_dually
# tar --exclude-vcs -cjvf oliveoil_dually-1.0.2.22.tar.bz2 oliveoil_dually
Source7:	oliveoil_dually-%{oliveoilver}.tar.bz2
# git clone https://code.alephobjects.com/diffusion/MARLIN/marlin.git
# cd marlin
# git checkout TAZ_6.02_MOARstruder_PID
# cd ..
# mv marlin oliveoil_moar
# tar --exclude-vcs -cjvf oliveoil_moar-1.0.2.22.tar.bz2 oliveoil_moar
Source8:	oliveoil_moar-%{oliveoilver}.tar.bz2
# PREBUILT FIRMWARE
# This is only here until we can figure out why we cannot build the identical files from the sources
Source10:	http://download.lulzbot.com/TAZ/6.02/software/firmware/Marlin_Oliveoil_Tilapia_v1.0.2.22_60d344d.hex
Source11:	http://download.lulzbot.com/TAZ/accessories/tool_heads/version_2/Dual_Extruder_v2/software/firmware/Marlin_TAZ6_Dual-v2_v1.0.2.22_46291ff.hex
Source12:	http://download.lulzbot.com/TAZ/accessories/tool_heads/version_2/Flexystruder_v2/software/firmware/Marlin_TAZ6_Flexy-v2_v1.0.2.22_712b850.hex
Source13:	http://download.lulzbot.com/TAZ/accessories/tool_heads/version_2/MOARstruder/software/firmware/Marlin_TAZ6_MOARstruder_v1.0.2.22_8e93658.hex
Source14:	http://download.lulzbot.com/Mini/1.04/software/firmware/Mini-Single-or-Flexystruder-LBHexagon-v1.1.0.11.hex

BuildRequires:	arduino-core
Requires:	cura-lulzbot
# This is the best representation I could come up with for the bundled
# arduino bits and libraries
Provides:	bundled(arduino)
Provides:	bundled(arduino:LiquidCrystal)
Provides:	bundled(arduino:SPI)
Provides:	bundled(arduino:U8glib)

%description
%{summary}.

%global platform mega2560

%prep
%setup -q -T -c %{name}-%{version} -a 1 -a 2 -a 3 -a 4 -a 5 -a 6 -a 7 -a 8
%setup -q -D -c -n %{name}-%{version}/Marlin_Gladiola_v%{Miniver}_%{Minirev}
%setup -q -D -T -c -n %{name}-%{version}

# Fix end-of-line encoding
sed -i 's/\r//g' oliveoil/README.md

# Ignore unused variable warnings
sed -i 's|-Wall|-Wall -Wno-unused-variable -Wno-unused-function -Wno-write-strings -Wno-overflow|g' oliveoil/Marlin/Makefile
sed -i 's|-Wall|-Wall -Wno-unused-variable -Wno-unused-function -Wno-write-strings -Wno-overflow|g' oliveoil_flexy/Marlin/Makefile
sed -i 's|-Wall|-Wall -Wno-unused-variable -Wno-unused-function -Wno-write-strings -Wno-overflow|g' oliveoil_dually/Marlin/Makefile
sed -i 's|-Wall|-Wall -Wno-unused-variable -Wno-unused-function -Wno-write-strings -Wno-overflow|g' oliveoil_moar/Marlin/Makefile

%build
%if %{buildfromsource}
# Mini
pushd Marlin_Gladiola_v%{Miniver}_%{Minirev}/Mini_Gladiola_Albatross_or_Brambling_v%{Miniver}_%{Minirev}/Marlin
make %{?_smp_mflags} avrdir=/usr/bin MACHINE=Mini-Single-or-Flexystruder-LBHexagon VERSION=v%{Miniver} HASH=%{Minirev}
mv Marlin_Mini-Single-or-Flexystruder-LBHexagon_v%{Miniver}_%{Minirev}.hex Mini-Single-or-Flexystruder-LBHexagon-v%{Miniver}.hex
popd

# oliveoil
pushd oliveoil/Marlin
make %{?_smp_mflags} avrdir=/usr/bin MACHINE=TAZ6_Single
mv Marlin_TAZ6_Single_v%{oliveoilver}_*.hex TAZ6_Single_Extruder_v%{oliveoilver}.hex
popd

# oliveoil_flexy
pushd oliveoil_flexy/Marlin
make %{?_smp_mflags} avrdir=/usr/bin MACHINE=TAZ6_Flexystruder
mv Marlin_TAZ6_Flexystruder_v%{oliveoilver}_*.hex TAZ6_Flexystruder_v%{oliveoilver}.hex
popd

# oliveoil_dually
pushd oliveoil_dually/Marlin
make %{?_smp_mflags} avrdir=/usr/bin MACHINE=TAZ6_Dual
mv Marlin_TAZ6_Dual_v%{oliveoilver}_*.hex TAZ6_Dual_v%{oliveoilver}.hex
popd

# oliveoil_moar
pushd oliveoil_moar/Marlin
make %{?_smp_mflags} avrdir=/usr/bin MACHINE=TAZ6_Moarstruder
mv Marlin_TAZ6_Moarstruder_v%{oliveoilver}_*.hex TAZ6_Moarstruder_v%{oliveoilver}.hex
popd

# Building the TAZ45 firmware is... not as easy.
# TODO: Figure out a way to do it.
%endif


%install
mkdir -p %{buildroot}%{_datadir}/cura-lulzbot/firmware/
%if %{buildfromsource}
install -Dpm0644 Marlin_Gladiola_v%{Miniver}_%{Minirev}/Mini_Gladiola_Albatross_or_Brambling_v%{Miniver}_%{Minirev}/Marlin/Mini-Single-or-Flexystruder-LBHexagon-v%{Miniver}.hex %{buildroot}%{_datadir}/cura-lulzbot/firmware/
install -Dpm0644 oliveoil/Marlin/TAZ6_Single_Extruder_v%{oliveoilver}.hex %{buildroot}%{_datadir}/cura-lulzbot/firmware/
install -Dpm0644 oliveoil_flexy/Marlin/TAZ6_Flexystruder_v%{oliveoilver}.hex %{buildroot}%{_datadir}/cura-lulzbot/firmware/
install -Dpm0644 oliveoil_dually/Marlin/TAZ6_Dual_v%{oliveoilver}.hex %{buildroot}%{_datadir}/cura-lulzbot/firmware/
install -Dpm0644 oliveoil_moar/Marlin/TAZ6_Moarstruder_v%{oliveoilver}.hex %{buildroot}%{_datadir}/cura-lulzbot/firmware/
%else
install -Dpm0644 %{SOURCE10} %{buildroot}%{_datadir}/cura-lulzbot/firmware/TAZ6_Single_Extruder_v%{oliveoilver}.hex
install -Dpm0644 %{SOURCE11} %{buildroot}%{_datadir}/cura-lulzbot/firmware/TAZ6_Dual_v%{oliveoilver}.hex
install -Dpm0644 %{SOURCE12} %{buildroot}%{_datadir}/cura-lulzbot/firmware/TAZ6_Flexystruder_v%{oliveoilver}.hex
install -Dpm0644 %{SOURCE13} %{buildroot}%{_datadir}/cura-lulzbot/firmware/TAZ6_Moarstruder_v%{oliveoilver}.hex
install -Dpm0644 %{SOURCE14} %{buildroot}%{_datadir}/cura-lulzbot/firmware/Mini-Single-or-Flexystruder-LBHexagon-v%{Miniver}.hex
%endif

pushd %{buildroot}%{_datadir}/cura-lulzbot/
mkdir resources
ln -s ../firmware resources/firmware
popd

%files
%doc oliveoil/README.md
%{_datadir}/cura-lulzbot/firmware/*
%{_datadir}/cura-lulzbot/resources/firmware
%license Marlin_Gladiola_v%{Miniver}_%{Minirev}/Mini_Gladiola_Albatross_or_Brambling_v%{Miniver}_%{Minirev}/LICENSE

%changelog
* Thu Nov 23 2017 Miro Hrončok <mhroncok@redhat.com> - 21.08-2
- Rebuilt to get it to f27

* Mon Aug 14 2017 Tom Callaway <spot@fedoraproject.org> - 21.08-1
- update to 21.08
- make symlink for cura2 compat
- do not build firmware from source (still no idea why it does not work)

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 21.03-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 21.03-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jan  4 2017 Tom Callaway <spot@fedoraproject.org> - 21.03-1
- update mini to 1.1.0.11

* Tue Nov 29 2016 Tom Callaway <spot@fedoraproject.org> - 21.00-2
- update mini to 1.1.0.10
- patch oliveoil* to build with gcc 6.2

* Fri Sep 30 2016 Tom Callaway <spot@fedoraproject.org> - 21.00-1
- update to 21.00 revisions
- drop patch merged upstream
- add TAZ6 moarstruder firmware

* Tue Sep  6 2016 Tom Callaway <spot@fedoraproject.org> - 20.03-2
- depend on cura-lulzbot
- do not own firmware dir (cura-lulzbot does)
- include README.md
- use smp_mflags
- add bundled provides
- add licensing comment
- update Gladiola to 1.1.0.9

* Wed Aug 31 2016 Tom Callaway <spot@fedoraproject.org> - 20.03-1
- update to firmware in cura-lulzbot 20.03

* Thu Jul 28 2016 Tom Callaway <spot@fedoraproject.org> - 20.01-1
- update to mini 1.1.0.5 f5e8154 (Gladiola)

* Tue Apr 12 2016 Tom Callaway <spot@fedoraproject.org> - 19.08-1
- initial package for lulzbot firmware (inspired a lot by Miro Hrončok's ultimaker2-marlin-firmware)
